<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑' : '添加'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="用户名" name="username">
        <a-input
          allow-clear
          placeholder="请输入用户名"
          v-model:value="form.username"
        />
      </a-form-item>
      <a-form-item label="密码" name="password">
        <a-input
          allow-clear
          placeholder="请输入密码"
          v-model:value="form.password"
        />
      </a-form-item>
      <a-form-item label="头像" name="portrait">
        <a-input
          allow-clear
          placeholder="请输入头像"
          v-model:value="form.portrait"
        />
      </a-form-item>
      <a-form-item label="手机号码" name="phone">
        <a-input
          allow-clear
          placeholder="请输入手机号码"
          v-model:value="form.phone"
        />
      </a-form-item>
      <a-form-item label="登陆次数" name="loginnum">
        <a-input
          allow-clear
          placeholder="请输入登陆次数"
          v-model:value="form.loginnum"
        />
      </a-form-item>
      <a-form-item label="最后登录IP" name="lastLoginIp">
        <a-input
          allow-clear
          placeholder="请输入最后登录IP"
          v-model:value="form.lastLoginIp"
        />
      </a-form-item>
      <a-form-item label="最后登录时间" name="lastLoginTime">
        <a-input
          allow-clear
          placeholder="请输入最后登录时间"
          v-model:value="form.lastLoginTime"
        />
      </a-form-item>
      <a-form-item label="真实姓名" name="realName">
        <a-input
          allow-clear
          placeholder="请输入真实姓名"
          v-model:value="form.realName"
        />
      </a-form-item>
      <a-form-item label="状态" name="status">
        <a-radio-group v-model:value="form.status">
          <a-radio :value="0">显示</a-radio>
          <a-radio :value="1">隐藏</a-radio>
        </a-radio-group>
      </a-form-item>
      <a-form-item label="场馆id集合，用于区分管理可管理的场馆" name="sid">
        <a-input
          allow-clear
          placeholder="请输入场馆id集合，用于区分管理可管理的场馆"
          v-model:value="form.sid"
        />
      </a-form-item>
      <a-form-item label="用户角色id" name="groupid">
        <a-input
          allow-clear
          placeholder="请输入用户角色id"
          v-model:value="form.groupid"
        />
      </a-form-item>
      <a-form-item label="" name="token">
        <a-input
          allow-clear
          placeholder="请输入"
          v-model:value="form.token"
        />
      </a-form-item>
      <a-form-item label="过期时间" name="expireTime">
        <a-input
          allow-clear
          placeholder="请输入过期时间"
          v-model:value="form.expireTime"
        />
      </a-form-item>
      <a-form-item label="员工卡号" name="cardCode">
        <a-input
          allow-clear
          placeholder="请输入员工卡号"
          v-model:value="form.cardCode"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addThinkAdmin, updateThinkAdmin } from '@/api/think/thinkAdmin';
  import { ThinkAdmin } from '@/api/think/thinkAdmin/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: ThinkAdmin | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<ThinkAdmin>({
    id: undefined,
    username: undefined,
    password: undefined,
    portrait: undefined,
    phone: undefined,
    loginnum: undefined,
    lastLoginIp: undefined,
    lastLoginTime: undefined,
    realName: undefined,
    status: undefined,
    sid: undefined,
    groupid: undefined,
    token: undefined,
    expireTime: undefined,
    cardCode: undefined,
    thinkAdminId: undefined,
    thinkAdminName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    thinkAdminName: [
      {
        required: true,
        type: 'string',
        message: '请填写名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateThinkAdmin : addThinkAdmin;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
